// CII(PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{

	char fname[FILENAME_MAX];
	int i;

	struct fpos md[] =
	{
		{ 0x09, 0x05, 0x0700 },
		{ 0x09, 0x0c, 0x0900 },
		{ 0x0a, 0x05, 0x0e00 },
		{ 0x0b, 0x03, 0x0a00 },
		{ 0x0b, 0x0d, 0x0900 },
		{ 0x0c, 0x06, 0x0b00 },
		{ 0x0d, 0x01, 0x1700 },
		{ 0x0e, 0x08, 0x1000 },
		{ 0x0f, 0x08, 0x0f00 },
		{ 0x10, 0x07, 0x2900 },
		{ 0x12, 0x10, 0x2d00 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x010);
	fcut("DRIVER", 0x15, 0x0a, 0x01, 0x0f, 0x01, 0x0000, 0x0500);

	// ȃf[^̐؂o
	for (i=0; md[i].sec; i++)
	{
		sprintf(fname,"MUS%02d",i);
		fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
	}
	return 0;
}

